"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.concat");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.find");

require("core-js/modules/es.array.from");

require("core-js/modules/es.array.is-array");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.array.map");

require("core-js/modules/es.array.reduce");

require("core-js/modules/es.array.sort");

require("core-js/modules/es.date.to-string");

require("core-js/modules/es.object.assign");

require("core-js/modules/es.object.keys");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.object.values");

require("core-js/modules/es.regexp.exec");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/es.string.match");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Preview = exports.renderIframe = void 0;

var _react = _interopRequireWildcard(require("react"));

var _api = require("@storybook/api");

var _coreEvents = require("@storybook/core-events");

var _addons = _interopRequireWildcard(require("@storybook/addons"));

var _merge = _interopRequireDefault(require("@storybook/api/dist/lib/merge"));

var _components = require("@storybook/components");

var _reactHelmetAsync = require("react-helmet-async");

var _toolbar = require("./toolbar");

var S = _interopRequireWildcard(require("./components"));

var _zoom = require("./zoom");

var _iframe = require("./iframe");

var _wrappers = require("./wrappers");

var _stringifyQueryParams = require("./stringifyQueryParams");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var renderIframe = function renderIframe(storyId, viewMode, id, baseUrl, scale, queryParams) {
  return _react["default"].createElement(_iframe.IFrame, {
    key: "iframe",
    id: "storybook-preview-iframe",
    title: id || 'preview',
    src: "".concat(baseUrl, "?id=").concat(storyId, "&viewMode=").concat(viewMode).concat((0, _stringifyQueryParams.stringifyQueryParams)(queryParams)),
    allowFullScreen: true,
    scale: scale
  });
};

exports.renderIframe = renderIframe;
renderIframe.displayName = "renderIframe";

var getWrapper = function getWrapper(getFn) {
  return Object.values(getFn(_addons.types.PREVIEW));
};

var getTabs = function getTabs(getFn) {
  return Object.values(getFn(_addons.types.TAB));
};

var getTools = function getTools(getFn) {
  return Object.values(getFn(_addons.types.TOOL));
};

var getToolsExtra = function getToolsExtra(getFn) {
  return Object.values(getFn(_addons.types.TOOLEXTRA));
};

var getDocumentTitle = function getDocumentTitle(description) {
  return description ? "".concat(description, " \u22C5 Storybook") : 'Storybook';
};

var mapper = function mapper(_ref) {
  var state = _ref.state,
      api = _ref.api;
  return {
    storyId: state.storyId,
    viewMode: state.viewMode,
    customCanvas: api.renderPreview,
    queryParams: state.customQueryParams,
    getElements: api.getElements,
    isLoading: !state.storiesConfigured
  };
};

var _ref4 = /*#__PURE__*/_react["default"].createElement(_components.Loader, {
  id: "preview-loader",
  role: "progressbar"
});

var createCanvas = function createCanvas(id) {
  var baseUrl = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'iframe.html';
  var withLoader = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  return {
    id: 'canvas',
    title: 'Canvas',
    route: function route(p) {
      return "/story/".concat(p.storyId);
    },
    match: function match(p) {
      return !!(p.viewMode && p.viewMode.match(/^(story|docs)$/));
    },
    render: function render(p) {
      return _react["default"].createElement(_api.Consumer, {
        filter: mapper
      }, function (_ref2) {
        var customCanvas = _ref2.customCanvas,
            storyId = _ref2.storyId,
            viewMode = _ref2.viewMode,
            queryParams = _ref2.queryParams,
            getElements = _ref2.getElements,
            isLoading = _ref2.isLoading;
        return _react["default"].createElement(_zoom.ZoomConsumer, null, function (_ref3) {
          var scale = _ref3.value;
          var wrappers = [].concat(_toConsumableArray(_wrappers.defaultWrappers), _toConsumableArray(getWrapper(getElements)));
          var data = [storyId, viewMode, id, baseUrl, scale, queryParams];
          var content = customCanvas ? customCanvas.apply(void 0, data) : renderIframe.apply(void 0, data);
          var props = {
            viewMode: viewMode,
            active: p.active,
            wrappers: wrappers,
            id: id,
            storyId: storyId,
            baseUrl: baseUrl,
            queryParams: queryParams,
            scale: scale,
            customCanvas: customCanvas
          };
          return _react["default"].createElement(_react["default"].Fragment, null, withLoader && isLoading && _ref4, _react["default"].createElement(_wrappers.ApplyWrappers, props, content));
        });
      });
    }
  };
};

var useTabs = function useTabs(id, baseUrl, withLoader, getElements, parameters) {
  var canvas = (0, _react.useMemo)(function () {
    return createCanvas(id, baseUrl, withLoader);
  }, [id, baseUrl, withLoader]);
  var tabsFromConfig = (0, _react.useMemo)(function () {
    return getTabs(getElements);
  }, [getElements]);
  return (0, _react.useMemo)(function () {
    return filterTabs([canvas].concat(_toConsumableArray(tabsFromConfig)), parameters);
  }, [canvas].concat(_toConsumableArray(tabsFromConfig), [parameters]));
};

var useViewMode = function useViewMode(docsOnly, viewMode) {
  return docsOnly && viewMode === 'story' ? 'docs' : viewMode;
};

var useTools = function useTools(getElements, tabs, viewMode, storyId, location, path) {
  var toolsFromConfig = (0, _react.useMemo)(function () {
    return getTools(getElements);
  }, [getElements]);
  var toolsExtraFromConfig = (0, _react.useMemo)(function () {
    return getToolsExtra(getElements);
  }, [getElements]);
  var tools = (0, _react.useMemo)(function () {
    return [].concat(_toConsumableArray(_toolbar.defaultTools), _toConsumableArray(toolsFromConfig));
  }, [_toolbar.defaultTools, toolsFromConfig]);
  var toolsExtra = (0, _react.useMemo)(function () {
    return [].concat(_toConsumableArray(_toolbar.defaultToolsExtra), _toConsumableArray(toolsExtraFromConfig));
  }, [_toolbar.defaultToolsExtra, toolsExtraFromConfig]);
  return (0, _react.useMemo)(function () {
    return filterTools(tools, toolsExtra, tabs, {
      viewMode: viewMode,
      storyId: storyId,
      location: location,
      path: path
    });
  }, [viewMode, storyId, location, path, tools, toolsExtra, tabs]);
};

var Preview = function Preview(props) {
  var api = props.api,
      id = props.id,
      location = props.location,
      options = props.options,
      _props$docsOnly = props.docsOnly,
      docsOnly = _props$docsOnly === void 0 ? false : _props$docsOnly,
      _props$storyId = props.storyId,
      storyId = _props$storyId === void 0 ? undefined : _props$storyId,
      _props$path = props.path,
      path = _props$path === void 0 ? undefined : _props$path,
      _props$description = props.description,
      description = _props$description === void 0 ? undefined : _props$description,
      _props$baseUrl = props.baseUrl,
      baseUrl = _props$baseUrl === void 0 ? 'iframe.html' : _props$baseUrl,
      _props$parameters = props.parameters,
      parameters = _props$parameters === void 0 ? undefined : _props$parameters,
      _props$withLoader = props.withLoader,
      withLoader = _props$withLoader === void 0 ? true : _props$withLoader;
  var isToolshown = options.isToolshown;
  var getElements = api.getElements; // eslint-disable-next-line react/destructuring-assignment

  var viewMode = useViewMode(docsOnly, props.viewMode);
  var tabs = useTabs(id, baseUrl, withLoader, getElements, parameters);

  var _useTools = useTools(getElements, tabs, viewMode, storyId, location, path),
      left = _useTools.left,
      right = _useTools.right;

  (0, _react.useEffect)(function () {
    api.emit(_coreEvents.SET_CURRENT_STORY, {
      storyId: storyId,
      viewMode: viewMode
    });
  }, [storyId, viewMode]);
  return _react["default"].createElement(_zoom.ZoomProvider, null, _react["default"].createElement(_react.Fragment, null, id === 'main' && _react["default"].createElement(_reactHelmetAsync.Helmet, {
    key: "description"
  }, _react["default"].createElement("title", null, getDocumentTitle(description))), (left || right) && _react["default"].createElement(_toolbar.Toolbar, {
    key: "toolbar",
    shown: isToolshown,
    border: true
  }, _react["default"].createElement(_react.Fragment, {
    key: "left"
  }, left), _react["default"].createElement(_react.Fragment, {
    key: "right"
  }, right)), _react["default"].createElement(S.FrameWrap, {
    key: "frame",
    offset: isToolshown ? 40 : 0
  }, tabs.map(function (p, i) {
    return (// @ts-ignore
      _react["default"].createElement(_react.Fragment, {
        key: p.id || p.key || i
      }, p.render({
        active: p.match({
          storyId: storyId,
          viewMode: viewMode,
          location: location,
          path: path
        })
      }))
    );
  }))));
};

exports.Preview = Preview;
Preview.displayName = "Preview";

function filterTabs(panels, parameters) {
  var _addons$getConfig = _addons["default"].getConfig(),
      previewTabs = _addons$getConfig.previewTabs;

  var parametersTabs = parameters ? parameters.previewTabs : undefined;

  if (previewTabs || parametersTabs) {
    // deep merge global and local settings
    var tabs = (0, _merge["default"])(previewTabs, parametersTabs);
    var arrTabs = Object.keys(tabs).map(function (key, index) {
      return Object.assign({
        index: index
      }, typeof tabs[key] === 'string' ? {
        title: tabs[key]
      } : tabs[key], {
        id: key
      });
    });
    return panels.filter(function (panel) {
      var t = arrTabs.find(function (tab) {
        return tab.id === panel.id;
      });
      return t === undefined || t.id === 'canvas' || !t.hidden;
    }).map(function (panel, index) {
      return Object.assign({}, panel, {
        index: index
      });
    }).sort(function (p1, p2) {
      var tab_1 = arrTabs.find(function (tab) {
        return tab.id === p1.id;
      }); // @ts-ignore

      var index_1 = tab_1 ? tab_1.index : arrTabs.length + p1.index;
      var tab_2 = arrTabs.find(function (tab) {
        return tab.id === p2.id;
      }); // @ts-ignore

      var index_2 = tab_2 ? tab_2.index : arrTabs.length + p2.index;
      return index_1 - index_2;
    }).map(function (panel) {
      var t = arrTabs.find(function (tab) {
        return tab.id === panel.id;
      });

      if (t) {
        return Object.assign({}, panel, {
          title: t.title || panel.title,
          disabled: t.disabled,
          hidden: t.hidden
        });
      }

      return panel;
    });
  }

  return panels;
}

function filterTools(tools, toolsExtra, tabs, _ref5) {
  var viewMode = _ref5.viewMode,
      storyId = _ref5.storyId,
      location = _ref5.location,
      path = _ref5.path;
  var tabsTool = (0, _toolbar.createTabsTool)(tabs);
  var toolsLeft = [tabs.filter(function (p) {
    return !p.hidden;
  }).length > 1 ? tabsTool : null].concat(_toConsumableArray(tools));

  var toolsRight = _toConsumableArray(toolsExtra); // if its a docsOnly page, even the 'story' view mode is considered 'docs'


  var filter = function filter(item) {
    return item && (!item.match || item.match({
      storyId: storyId,
      viewMode: viewMode,
      location: location,
      path: path
    }));
  };

  var displayItems = function displayItems(list) {
    return list.reduce(function (acc, item, index) {
      return item ? // @ts-ignore
      _react["default"].createElement(_react.Fragment, {
        key: item.id || item.key || "f-".concat(index)
      }, acc, item.render({}) || item) : acc;
    }, null);
  };

  var left = displayItems(toolsLeft.filter(filter));
  var right = displayItems(toolsRight.filter(filter));
  return {
    left: left,
    right: right
  };
}