"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.symbol");

require("core-js/modules/es.array.concat");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.index-of");

require("core-js/modules/es.array.map");

require("core-js/modules/es.object.keys");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultToolsExtra = exports.defaultTools = exports.createTabsTool = exports.ejectTool = exports.copyTool = exports.fullScreenTool = exports.Toolbar = void 0;

var _react = _interopRequireWildcard(require("react"));

var _copyToClipboard = _interopRequireDefault(require("copy-to-clipboard"));

var _theming = require("@storybook/theming");

var _components = require("@storybook/components");

var _api = require("@storybook/api");

var _stringifyQueryParams = require("./stringifyQueryParams");

var _zoom = require("./zoom");

var S = _interopRequireWildcard(require("./components"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Bar = function Bar(_ref) {
  var shown = _ref.shown,
      props = _objectWithoutProperties(_ref, ["shown"]);

  return _react["default"].createElement(_components.FlexBar, props);
};

Bar.displayName = "Bar";
var Toolbar = (0, _theming.styled)(Bar)({
  position: 'absolute',
  left: 0,
  right: 0,
  top: 0,
  transition: 'transform .2s linear'
}, function (_ref2) {
  var shown = _ref2.shown;
  return {
    tranform: shown ? 'translateY(0px)' : 'translateY(-40px)'
  };
});
exports.Toolbar = Toolbar;

var fullScreenMapper = function fullScreenMapper(_ref3) {
  var api = _ref3.api,
      state = _ref3.state;
  return {
    toggle: api.toggleFullscreen,
    value: state.layout.isFullscreen
  };
};

var fullScreenTool = {
  title: 'fullscreen',
  match: function match(p) {
    return p.viewMode === 'story';
  },
  render: function render() {
    return _react["default"].createElement(_api.Consumer, {
      filter: fullScreenMapper
    }, function (_ref4) {
      var toggle = _ref4.toggle,
          value = _ref4.value;
      return _react["default"].createElement(S.DesktopOnly, null, _react["default"].createElement(_components.IconButton, {
        key: "full",
        onClick: toggle,
        title: value ? 'Exit full screen' : 'Go full screen'
      }, _react["default"].createElement(_components.Icons, {
        icon: value ? 'close' : 'expand'
      })));
    });
  }
};
exports.fullScreenTool = fullScreenTool;

var copyMapper = function copyMapper(_ref5) {
  var state = _ref5.state;
  return {
    origin: state.location.origin,
    pathname: state.location.pathname,
    storyId: state.storyId,
    baseUrl: 'iframe.html',
    queryParams: state.customQueryParams
  };
};

var _ref7 = /*#__PURE__*/_react["default"].createElement(_components.Icons, {
  icon: "copy"
});

var copyTool = {
  title: 'copy',
  match: function match(p) {
    return p.viewMode === 'story';
  },
  render: function render() {
    return _react["default"].createElement(_api.Consumer, {
      filter: copyMapper
    }, function (_ref6) {
      var baseUrl = _ref6.baseUrl,
          storyId = _ref6.storyId,
          origin = _ref6.origin,
          pathname = _ref6.pathname,
          queryParams = _ref6.queryParams;
      return _react["default"].createElement(_components.IconButton, {
        key: "copy",
        onClick: function onClick() {
          return (0, _copyToClipboard["default"])("".concat(origin).concat(pathname).concat(baseUrl, "?id=").concat(storyId).concat((0, _stringifyQueryParams.stringifyQueryParams)(queryParams)));
        },
        title: "Copy canvas link"
      }, _ref7);
    });
  }
};
exports.copyTool = copyTool;

var ejectMapper = function ejectMapper(_ref8) {
  var state = _ref8.state;
  return {
    baseUrl: 'iframe.html',
    storyId: state.storyId,
    queryParams: state.customQueryParams
  };
};

var _ref10 = /*#__PURE__*/_react["default"].createElement(_components.Icons, {
  icon: "share"
});

var ejectTool = {
  title: 'eject',
  match: function match(p) {
    return p.viewMode === 'story';
  },
  render: function render() {
    return _react["default"].createElement(_api.Consumer, {
      filter: ejectMapper
    }, function (_ref9) {
      var baseUrl = _ref9.baseUrl,
          storyId = _ref9.storyId,
          queryParams = _ref9.queryParams;
      return _react["default"].createElement(_components.IconButton, {
        key: "opener",
        href: "".concat(baseUrl, "?id=").concat(storyId).concat((0, _stringifyQueryParams.stringifyQueryParams)(queryParams)),
        target: "_blank",
        title: "Open canvas in new tab"
      }, _ref10);
    });
  }
};
exports.ejectTool = ejectTool;

var _ref12 = /*#__PURE__*/_react["default"].createElement(_components.Separator, null);

var zoomTool = {
  title: 'zoom',
  match: function match(p) {
    return p.viewMode === 'story';
  },
  render: function render() {
    return _react["default"].createElement(_react.Fragment, null, _react["default"].createElement(_zoom.ZoomConsumer, null, function (_ref11) {
      var _set = _ref11.set,
          value = _ref11.value;
      return _react["default"].createElement(_zoom.Zoom, {
        key: "zoom",
        set: function set(v) {
          return _set(value * v);
        },
        reset: function reset() {
          return _set(1);
        }
      });
    }), _ref12);
  }
};

var tabsMapper = function tabsMapper(_ref13) {
  var state = _ref13.state;
  return {
    viewMode: state.docsOnly,
    storyId: state.storyId,
    path: state.path,
    location: state.location
  };
};

var _ref15 = /*#__PURE__*/_react["default"].createElement(_components.Separator, null);

var createTabsTool = function createTabsTool(tabs) {
  return {
    title: 'title',
    render: function render() {
      return _react["default"].createElement(_api.Consumer, {
        filter: tabsMapper
      }, function (_ref14) {
        var viewMode = _ref14.viewMode,
            storyId = _ref14.storyId,
            path = _ref14.path,
            location = _ref14.location;
        return _react["default"].createElement(_react.Fragment, null, _react["default"].createElement(_components.TabBar, {
          key: "tabs"
        }, tabs.filter(function (p) {
          return !p.hidden;
        }).map(function (t, index) {
          var to = t.route({
            storyId: storyId,
            viewMode: viewMode,
            path: path,
            location: location
          });
          var isActive = path === to;
          return _react["default"].createElement(S.UnstyledLink, {
            key: t.id || "l".concat(index),
            to: to
          }, _react["default"].createElement(_components.TabButton, {
            disabled: t.disabled,
            active: isActive
          }, t.title));
        })), _ref15);
      });
    }
  };
};

exports.createTabsTool = createTabsTool;
var defaultTools = [zoomTool];
exports.defaultTools = defaultTools;
var defaultToolsExtra = [fullScreenTool, ejectTool, copyTool];
exports.defaultToolsExtra = defaultToolsExtra;