"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _theming = require("@storybook/theming");

var _components = require("@storybook/components");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var sharedStyles = {
  height: 10,
  width: 10,
  marginLeft: -5,
  marginRight: -5,
  display: 'block'
};
var Icon = (0, _theming.styled)(_components.Icons)(sharedStyles, function (_ref) {
  var theme = _ref.theme;
  return {
    color: theme.color.secondary
  };
});

var Img = _theming.styled.img(sharedStyles);

var Placeholder = _theming.styled.div(sharedStyles);

var _ref3 = /*#__PURE__*/_react["default"].createElement(Placeholder, null);

var ListItemIcon = function ListItemIcon(_ref2) {
  var icon = _ref2.icon,
      imgSrc = _ref2.imgSrc;

  if (icon) {
    return _react["default"].createElement(Icon, {
      icon: icon
    });
  }

  if (imgSrc) {
    return _react["default"].createElement(Img, {
      src: imgSrc,
      alt: "image"
    });
  }

  return _ref3;
};

ListItemIcon.displayName = "ListItemIcon";
var _default = ListItemIcon;
exports["default"] = _default;