"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.regexp.exec");

require("core-js/modules/es.string.search");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useMenu = exports.MenuItemIcon = void 0;

var _react = _interopRequireWildcard(require("react"));

var _components = require("@storybook/components");

var _theming = require("@storybook/theming");

var _shortcut = require("../libs/shortcut");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var focusableUIElements = {
  storySearchField: 'storybook-explorer-searchfield',
  storyListMenu: 'storybook-explorer-menu',
  storyPanelRoot: 'storybook-panel-root'
};

var shortcutToHumanStringIfEnabled = function shortcutToHumanStringIfEnabled(shortcuts, enableShortcuts) {
  return enableShortcuts ? (0, _shortcut.shortcutToHumanString)(shortcuts) : null;
};

var sharedStyles = {
  height: 10,
  width: 10,
  marginLeft: -5,
  marginRight: -5,
  display: 'block'
};
var Icon = (0, _theming.styled)(_components.Icons)(sharedStyles, function (_ref) {
  var theme = _ref.theme;
  return {
    color: theme.color.secondary
  };
});

var Img = _theming.styled.img(sharedStyles);

var Placeholder = _theming.styled.div({
  sharedStyles: sharedStyles
});

var _ref3 = /*#__PURE__*/_react["default"].createElement(Placeholder, null);

var MenuItemIcon = function MenuItemIcon(_ref2) {
  var icon = _ref2.icon,
      imgSrc = _ref2.imgSrc;

  if (icon) {
    return _react["default"].createElement(Icon, {
      icon: icon
    });
  }

  if (imgSrc) {
    return _react["default"].createElement(Img, {
      src: imgSrc,
      alt: "image"
    });
  }

  return _ref3;
};

exports.MenuItemIcon = MenuItemIcon;
MenuItemIcon.displayName = "MenuItemIcon";

var _ref4 = /*#__PURE__*/_react["default"].createElement(MenuItemIcon, {
  icon: "check"
});

var _ref5 = /*#__PURE__*/_react["default"].createElement(MenuItemIcon, null);

var _ref6 = /*#__PURE__*/_react["default"].createElement(MenuItemIcon, {
  icon: "check"
});

var _ref7 = /*#__PURE__*/_react["default"].createElement(MenuItemIcon, null);

var _ref8 = /*#__PURE__*/_react["default"].createElement(MenuItemIcon, null);

var _ref9 = /*#__PURE__*/_react["default"].createElement(MenuItemIcon, null);

var _ref10 = /*#__PURE__*/_react["default"].createElement(MenuItemIcon, null);

var _ref11 = /*#__PURE__*/_react["default"].createElement(MenuItemIcon, null);

var _ref12 = /*#__PURE__*/_react["default"].createElement(MenuItemIcon, null);

var _ref13 = /*#__PURE__*/_react["default"].createElement(MenuItemIcon, null);

var _ref14 = /*#__PURE__*/_react["default"].createElement(MenuItemIcon, null);

var _ref15 = /*#__PURE__*/_react["default"].createElement(_components.Badge, {
  status: "positive"
}, "Update");

var _ref16 = /*#__PURE__*/_react["default"].createElement(MenuItemIcon, null);

var _ref17 = /*#__PURE__*/_react["default"].createElement(MenuItemIcon, null);

var _ref18 = /*#__PURE__*/_react["default"].createElement(MenuItemIcon, null);

var useMenu = function useMenu(api, isFullscreen, showPanel, showNav, enableShortcuts) {
  var shortcutKeys = api.getShortcutKeys();
  var sidebarToggle = (0, _react.useMemo)(function () {
    return {
      id: 'S',
      title: 'Show sidebar',
      onClick: function onClick() {
        return api.toggleNav();
      },
      right: shortcutToHumanStringIfEnabled(shortcutKeys.toggleNav, enableShortcuts),
      left: showNav ? _ref4 : _ref5
    };
  }, [api, shortcutToHumanStringIfEnabled, enableShortcuts, shortcutKeys, showNav]);
  var addonsToggle = (0, _react.useMemo)(function () {
    return {
      id: 'A',
      title: 'Show addons',
      onClick: function onClick() {
        return api.togglePanel();
      },
      right: shortcutToHumanStringIfEnabled(shortcutKeys.togglePanel, enableShortcuts),
      left: showPanel ? _ref6 : _ref7
    };
  }, [api, shortcutToHumanStringIfEnabled, enableShortcuts, shortcutKeys, showPanel]);
  var addonsOrientationToggle = (0, _react.useMemo)(function () {
    return {
      id: 'D',
      title: 'Change addons orientation',
      onClick: function onClick() {
        return api.togglePanelPosition();
      },
      right: shortcutToHumanStringIfEnabled(shortcutKeys.panelPosition, enableShortcuts),
      left: _ref8
    };
  }, [api, shortcutToHumanStringIfEnabled, enableShortcuts, shortcutKeys]);
  var fullscreenToggle = (0, _react.useMemo)(function () {
    return {
      id: 'F',
      title: 'Go full screen',
      onClick: function onClick() {
        return api.toggleFullscreen();
      },
      right: shortcutToHumanStringIfEnabled(shortcutKeys.fullScreen, enableShortcuts),
      left: isFullscreen ? 'check' : _ref9
    };
  }, [api, shortcutToHumanStringIfEnabled, enableShortcuts, shortcutKeys, isFullscreen]);
  var searchToggle = (0, _react.useMemo)(function () {
    return {
      id: '/',
      title: 'Search',
      onClick: function onClick() {
        return api.focusOnUIElement(focusableUIElements.storySearchField);
      },
      right: shortcutToHumanStringIfEnabled(shortcutKeys.search, enableShortcuts),
      left: _ref10
    };
  }, [api, shortcutToHumanStringIfEnabled, enableShortcuts, shortcutKeys]);
  var up = (0, _react.useMemo)(function () {
    return {
      id: 'up',
      title: 'Previous component',
      onClick: function onClick() {
        return api.jumpToComponent(-1);
      },
      right: shortcutToHumanStringIfEnabled(shortcutKeys.prevComponent, enableShortcuts),
      left: _ref11
    };
  }, [api, shortcutToHumanStringIfEnabled, enableShortcuts, shortcutKeys]);
  var down = (0, _react.useMemo)(function () {
    return {
      id: 'down',
      title: 'Next component',
      onClick: function onClick() {
        return api.jumpToComponent(1);
      },
      right: shortcutToHumanStringIfEnabled(shortcutKeys.nextComponent, enableShortcuts),
      left: _ref12
    };
  }, [api, shortcutToHumanStringIfEnabled, enableShortcuts, shortcutKeys]);
  var prev = (0, _react.useMemo)(function () {
    return {
      id: 'prev',
      title: 'Previous story',
      onClick: function onClick() {
        return api.jumpToStory(-1);
      },
      right: shortcutToHumanStringIfEnabled(shortcutKeys.prevStory, enableShortcuts),
      left: _ref13
    };
  }, [api, shortcutToHumanStringIfEnabled, enableShortcuts, shortcutKeys]);
  var next = (0, _react.useMemo)(function () {
    return {
      id: 'next',
      title: 'Next story',
      onClick: function onClick() {
        return api.jumpToStory(1);
      },
      right: shortcutToHumanStringIfEnabled(shortcutKeys.nextStory, enableShortcuts),
      left: _ref14
    };
  }, [api, shortcutToHumanStringIfEnabled, enableShortcuts, shortcutKeys]);
  var about = (0, _react.useMemo)(function () {
    return {
      id: 'about',
      title: 'About your Storybook',
      onClick: function onClick() {
        return api.navigate('/settings/about');
      },
      right: api.versionUpdateAvailable() && _ref15,
      left: _ref16
    };
  }, [api, shortcutToHumanStringIfEnabled, enableShortcuts, shortcutKeys]);
  var shortcuts = (0, _react.useMemo)(function () {
    return {
      id: 'shortcuts',
      title: 'Keyboard shortcuts',
      onClick: function onClick() {
        return api.navigate('/settings/shortcuts');
      },
      right: shortcutToHumanStringIfEnabled(shortcutKeys.shortcutsPage, enableShortcuts),
      left: _ref17
    };
  }, [api, shortcutToHumanStringIfEnabled, enableShortcuts, shortcutKeys]);
  var collapse = (0, _react.useMemo)(function () {
    return {
      id: 'collapse',
      title: 'Collapse all',
      onClick: function onClick() {
        return api.collapseAll();
      },
      right: (0, _shortcut.shortcutToHumanString)(shortcutKeys.collapseAll),
      left: _ref18
    };
  }, [api, shortcutToHumanStringIfEnabled, enableShortcuts, shortcutKeys]);
  return (0, _react.useMemo)(function () {
    return [sidebarToggle, addonsToggle, addonsOrientationToggle, fullscreenToggle, searchToggle, up, down, prev, next, about, shortcuts, collapse];
  }, [sidebarToggle, addonsToggle, addonsOrientationToggle, fullscreenToggle, searchToggle, up, down, prev, next, about, shortcuts, collapse]);
};

exports.useMenu = useMenu;