"use strict";

require("core-js/modules/es.array.concat");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.assign");

require("core-js/modules/es.regexp.exec");

require("core-js/modules/es.string.replace");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _global = require("global");

var _react = _interopRequireDefault(require("react"));

var _api = require("@storybook/api");

var _preview = require("../components/preview/preview");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var nonAlphanumSpace = /[^a-z0-9 ]/gi;
var doubleSpace = /\s\s/gi;

var replacer = function replacer(match) {
  return " ".concat(match, " ");
};

var addExtraWhiteSpace = function addExtraWhiteSpace(input) {
  return input.replace(nonAlphanumSpace, replacer).replace(doubleSpace, ' ');
};

var getDescription = function getDescription(item) {
  if ((0, _api.isRoot)(item)) {
    return item.name ? "".concat(item.name, " \u22C5 Storybook") : 'Storybook';
  }

  if ((0, _api.isGroup)(item)) {
    return item.name ? "".concat(item.name, " \u22C5 Storybook") : 'Storybook';
  }

  if ((0, _api.isStory)(item)) {
    var kind = item.kind,
        name = item.name;
    return kind && name ? addExtraWhiteSpace("".concat(kind, " - ").concat(name, " \u22C5 Storybook")) : 'Storybook';
  }

  return 'Storybook';
};

var mapper = function mapper(_ref) {
  var api = _ref.api,
      state = _ref.state;
  var layout = state.layout,
      location = state.location,
      customQueryParams = state.customQueryParams,
      storyId = state.storyId;
  var story = api.getData(storyId);
  var parameters = story ? story.parameters : {};
  var docsOnly = story && story.parameters ? !!story.parameters.docsOnly : false;
  return Object.assign({
    api: api,
    options: layout,
    description: getDescription(story)
  }, api.getUrlState(), {
    queryParams: customQueryParams,
    docsOnly: docsOnly,
    location: location,
    parameters: parameters
  });
};

var getBaseUrl = function getBaseUrl() {
  try {
    return _global.PREVIEW_URL || 'iframe.html';
  } catch (e) {
    return 'iframe.html';
  }
};

var PreviewConnected = _react["default"].memo(function (props) {
  return _react["default"].createElement(_api.Consumer, {
    filter: mapper
  }, function (fromState) {
    var p = Object.assign({}, props, {
      baseUrl: getBaseUrl()
    }, fromState);
    return _react["default"].createElement(_preview.Preview, p);
  });
});

PreviewConnected.displayName = 'PreviewConnected';
var _default = PreviewConnected;
exports["default"] = _default;