/// <reference types="lodash/common/common" />
/// <reference types="lodash/common/array" />
/// <reference types="lodash/common/collection" />
/// <reference types="lodash/common/date" />
/// <reference types="lodash/common/function" />
/// <reference types="lodash/common/lang" />
/// <reference types="lodash/common/math" />
/// <reference types="lodash/common/number" />
/// <reference types="lodash/common/object" />
/// <reference types="lodash/common/seq" />
/// <reference types="lodash/common/string" />
/// <reference types="lodash/common/util" />
import React, { PureComponent, ComponentType, FunctionComponent } from 'react';
import { Dataset, ExpandedSet, SelectedSet } from './utils';
declare const Tree: FunctionComponent<{
    root: string;
    depth: number;
    dataset: Dataset;
    expanded: ExpandedSet;
    selected: SelectedSet;
    events?: any;
    Branch: ComponentType<any>;
    Link?: ComponentType<any>;
    List?: ComponentType<any>;
    Leaf?: ComponentType<any>;
    Head?: ComponentType<any>;
}>;
export interface TreeStateState {
    unfilteredExpanded: SelectedSet;
    filteredExpanded: ExpandedSet;
    filter: string | null;
    lastSelectedId: string | null;
}
export interface TreeStateProps {
    dataset: Dataset;
    selectedId: string;
    prefix: string;
    filter?: string;
    event?: any;
    Filter: ComponentType<any>;
    List: ComponentType<any>;
    Title: ComponentType<any>;
    Link: ComponentType<any>;
    Leaf: ComponentType<any>;
    Head: ComponentType<any>;
    Section: ComponentType<any>;
    Message: ComponentType<any>;
}
declare class TreeState extends PureComponent<TreeStateProps, TreeStateState> {
    state: TreeStateState;
    static getDerivedStateFromProps(props: TreeStateProps, state: TreeStateState): {
        lastSelectedId: string;
        unfilteredExpanded: Record<string, boolean>;
    };
    static defaultProps: Partial<TreeStateProps>;
    events: {
        onClick: (e: React.SyntheticEvent<Element, Event>, item: import("@storybook/api").Root | import("@storybook/api").Group | import("@storybook/api").Story) => void;
        onFilter: ((inputFilter: any) => void) & import("lodash").Cancelable;
        onKeyUp: (e: KeyboardEvent, item: import("@storybook/api").Root | import("@storybook/api").Group | import("@storybook/api").Story) => void;
    };
    componentDidMount(): void;
    componentWillUnmount(): void;
    updateExpanded: (expanded: string | boolean) => void;
    onCollapseAll: () => void;
    onExpandAll: () => void;
    render(): JSX.Element;
}
export { TreeState, Tree };
